// Generated by CoffeeScript 1.9.3
var CssLint, LintError, LintWarning, rule_parser;

CssLint = require('csslint').CSSLint;

LintError = require('../error/lint-error');

LintWarning = require('../warning/lint-warning');

rule_parser = require('./rule/_parser');

module.exports = function(inf, cb) {
  return rule_parser(inf, 'css', cb, function(cfg) {
    var data, desc, err, i, len, message, msg, pos, ref, ref1, title;
    try {
      data = CssLint.verify(inf.source, cfg);
      ref = data != null ? data.messages : void 0;
      for (i = 0, len = ref.length; i < len; i++) {
        msg = ref[i];
        pos = LintError.parsePos(msg.line, msg.col, -1, -1);
        message = String(msg.message).split(' at line ')[0];
        desc = message;
        title = (ref1 = msg.rule) != null ? ref1.name : void 0;
        if (msg.type === 'error') {
          inf.res.errors.push(new LintError(inf, msg, pos, desc, title));
        } else {
          inf.res.warnings.push(new LintWarning(inf, msg, pos, desc, title));
        }
      }
    } catch (_error) {
      err = _error;
      inf.res.errors.push(new LintError(inf, err));
    }
    return cb();
  });
};
